!function($){

    "use strict"; // jshint ;_;

    /* SCROLLTABLE PUBLIC CLASS DEFINITION
     * ================================= */

    var Scrolltable = function (element, options) {
        this.$zone = $("<div></div>").addClass("scrolltable")
        this.$element = $(element)
        this.options = $.extend({}, $.fn.scrolltable.defaults, options)

        this.drawTable()
    }

    Scrolltable.prototype = {

        constructor: Scrolltable

        , drawTable: function() {
            this.$element.wrap(this.$zone)
            $("<div></div>").addClass("scrolltable-header").insertBefore(this.$element)
            var scrollable = $("<div></div>").addClass("scrolltable-div").css("max-height", this.options.maxHeight + "px")
            this.$element.wrap(scrollable)

            this.$element.find("th").each(function(index) {
                $(this).wrapInner("<div></div>")
            })
        }

    }

    /* SCROLLTABLE PLUGIN DEFINITION
     * =========================== */

    var old = $.fn.scrolltable

    $.fn.scrolltable = function (option) {
        return this.each(function () {
            var $this = $(this)
                , data = $this.data('scrolltable')
                , options = typeof option == 'object' && option
            if (!data) $this.data('scrolltable', (data = new Scrolltable(this, options)))
            if (typeof option == 'string') data[option]()
        })
    }

    $.fn.scrolltable.defaults = {
        maxHeight: 100
    }

    $.fn.scrolltable.Constructor = Scrolltable


    /* SCROLLTABLE NO CONFLICT
     * =================== */

    $.fn.scrolltable.noConflict = function () {
        $.fn.scrolltable = old
        return this
    }

    /* SCROLLTABLE DATA-API
     * ================== */

    $(document).on('focus.scrolltable.data-api', '[data-provide="scrolltable"]', function (e) {
        var $this = $(this)
        if ($this.data('scrolltable')) return
        e.preventDefault()
        $this.scrolltable($this.data())
    })

}(window.jQuery);